class NamedError extends Error {
  constructor(method) {
    super(method);
    this.name = this.constructor.name;
  }
}

class NotFoundError extends NamedError {
  constructor(value) {
    super(`${value} not found`);
  }
}

class MethodNotAllowedError extends NamedError {
  constructor(method) {
    super(`${method} method is not allowed`);
  }
}

class UnauthorizedError extends NamedError {
  constructor() {
    super(`Unauthorized`);
  }
}

module.exports = { NamedError, NotFoundError, MethodNotAllowedError, UnauthorizedError };